# RecorderTask

Extends \Task Implements \SubBuildListener

Adds a listener to the current build process that records the output to a file.

Several recorders can exist at the same time. Each recorder is associated with a file. The filename is used as a unique identifier for the recorders. The first call to the recorder task with an unused filename will create a recorder (using the parameters provided) and add it to the listeners of the build. All subsequent calls to the recorder task using this filename will modify that recorders state (recording or not) or other properties (like logging level).

Some technical issues: the file's print stream is flushed for "finished" events (buildFinished, targetFinished and taskFinished), and is closed on a buildFinished event.

author | Siad Ardroumli siad.ardroumli@gmail.com
package | phing.tasks.system

### Methods

## Cleans recorder registry.

    buildFinished(\BuildEvent $event)

### Arguments

#### $event

`\BuildEvent`

ignored.

## Empty implementation required by SubBuildListener interface.

    buildStarted(\BuildEvent $event)

### Arguments

#### $event

`\BuildEvent`

ignored.

## cleans recorder registry and removes itself from BuildListener list.

    cleanup()

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Gets the recorder that's associated with the passed in name. If the recorder doesn't exist, then a new one is created.

    getRecorder(string $name, \Project $proj) : \RecorderEntry

throws | on error

### Arguments

#### $name

`string`

the name of the recorder

#### $proj

`\Project`

the current project

### Response

`\RecorderEntry`

a recorder

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Empty implementation required by SubBuildListener interface.

    messageLogged(\BuildEvent $event)

### Arguments

#### $event

`\BuildEvent`

ignored.

## Perfrom this task

    perform()

inherited

throws |

## Sets the action for the associated recorder entry.

    setAction(string $action)

### Arguments

#### $action

`string`

The action for the entry to take: start or stop.

## Whether or not the logger should append to a previous file.

    setAppend(boolean $append)

### Arguments

#### $append

`boolean`

if true, append to a previous file.

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## Set emacs mode.

    setEmacsMode(boolean $emacsMode)

### Arguments

#### $emacsMode

`boolean`

if true use emacs mode

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the level to which this recorder entry should log to.

    setLoglevel(string $level)

### Arguments

#### $level

`string`

the level to set.

## Sets the name of the file to log to, and the name of the recorder entry.

    setName(string $fname)

### Arguments

#### $fname

`string`

File name of logfile.

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## Cleans recorder registry, if this is the subbuild the task has been created in.

    subBuildFinished(\BuildEvent $event)

### Arguments

#### $event

`\BuildEvent`

ignored.

## Empty implementation required by SubBuildListener interface.

    subBuildStarted(\BuildEvent $event)

### Arguments

#### $event

`\BuildEvent`

ignored.

## Empty implementation required by SubBuildListener interface.

    targetFinished(\BuildEvent $event)

### Arguments

#### $event

`\BuildEvent`

ignored.

## Empty implementation required by SubBuildListener interface.

    targetStarted(\BuildEvent $event)

### Arguments

#### $event

`\BuildEvent`

ignored.

## Empty implementation required by SubBuildListener interface.

    taskFinished(\BuildEvent $event)

### Arguments

#### $event

`\BuildEvent`

ignored.

## Empty implementation required by SubBuildListener interface.

    taskStarted(\BuildEvent $event)

### Arguments

#### $event

`\BuildEvent`

ignored.

### Properties

## The name of the file to record to.

    filename :

### Type(s)

``

## Whether or not to append. Need Boolean to record an unset state (null).

    append :

### Type(s)

``

## Whether to start or stop recording. Need Boolean to record an unset state (null).

    start :

### Type(s)

``

## The level to log at. A level of -1 means not initialized yet.

    loglevel :

### Type(s)

``

## Strip task banners if true.

    emacsMode :

### Type(s)

``

## logLevelChoices

    logLevelChoices :

### Type(s)

``

## The list of recorder entries.

    recorderEntries : array<mixed,\RecorderEntry>

static

var |

### Type(s)

`array<mixed,\RecorderEntry>`

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`